pro polygonROI, roiName

	tstrt=SYSTIME(1)

	envi_batch_init

        resolve_routine,envi_get_roi,/is_function
        resolve_routine,envi_create_roi,/is_function
        resolve_routine,envi_get_roi_ids,/is_function

	;Lectura de parametros
	readParam, getenv('paramFile'), 'SITE', 'NAME', nSite
	readParam, getenv('paramFile'), 'SITE', 'SMOOTH_WIDTH', smooth_width

	;Cargo la informacion de mascara
	readData, nSite + '_curvature_azimuthal', mask, dims=dims_1, nl=nl_1, mapinfo=map_1
	;Controlo que haya encontrado los archivos necesarios
	if (mask[0] eq -1) then return

	dimx = long(dims_1[2]+1)
	dimy = long(dims_1[4]+1)

	;Gestiono la roi de interes
	envi_open_file, nSite + '_curvature_azimuthal', r_fid=fid

	envi_delete_rois, /all
	envi_restore_rois, roiName
	roi_ids = envi_get_roi_ids()
	roiData = envi_get_roi(roi_ids[0], roi_name=rName)
; stop
	;Identifico las posiciones
	roiDataUniq = roiData[uniq(roiData)]
	py = long(roiDataUniq/dimx)
	px = roiDataUniq-py*dimx

	;Almacenamos la nueva roi
	roiID = envi_create_roi(color=255, name=rName, ns=dimx, nl=dimy)

	px = [px,px[0]]
	py = [py,py[0]]

	envi_define_roi, roiID, /polygon, xpts=px-0.5, ypts=py-0.5

	envi_save_rois, 'POL_' + roiName, roiID
	envi_delete_rois, /all
return
end
